c
c     diagonalisiert eine hermitesche Matrix
c     Das Programm bestimmt die Dimension der Matrix selbstndig und
c     geht dabei davon aus, dass die letzte Zeile bzw. Spalte besetzt ist.
c
c
      program diag
      implicit   none
      integer    k,L,Dim,ThisDim
      Parameter  (Dim=42000)
      integer    Error
*
      complex*16 MatrixElement,Matrix
      real*8     Eigenwerte(Dim)
*
      integer    wkDim,rwkDim
c      parameter  (wkDim=Dim*Dim+2*Dim) ! minimal
      parameter  (wkDim=714000)
c      parameter  (rwkDim=2*Dim*Dim+5*Dim+1) ! minimal
      parameter  (rwkDim=42000)
      complex*16 wk
      real*8     rwk
      integer    iwk(10*Dim)
*     
      character  Filename*50
*
      real*8     time1
      integer*4  Count1,Count2,Rate,Max
*
      character  Version*50
*
      common/M/Matrix(Dim,Dim)
      common/R/wk(wkDim),rwk(rwkDim)
*
      Version= 'diag 07 Juergen Schnack  12.11.2020'
*---------------------------------------------------------------
*
*     output
*
      write(6,'(a)') Version
*
      Matrix = DCMPLX(0.d0,0.d0)
*
      ThisDim = 0
*
*     read matrix
*
      call GETARG(1,FileName)
      open(1,file=Filename)
 100  read(1,*,err=110,end=110) k,L,MatrixElement
      k = k + 1                 ! C-Syntax
      L = L + 1                 ! C-Syntax
      Matrix(k,L) = MatrixElement
      IF(k.gt.ThisDim) ThisDim=k
      IF(L.gt.ThisDim) ThisDim=L
      goto 100
 110  continue
      close(1)
      write(6,*) 'Dimension der Matrix = ',ThisDim
*
*     Diagonalisieren
*

      ThisDim = 1000
      write(6,*) 'Take only = ',ThisDim,'x',ThisDim

      call System_Clock(Count1,Rate,Max)
      call ZHEEVD('N','U',ThisDim,Matrix,Dim,Eigenwerte,wk,
     &     wkDim,rwk,rwkDim,iwk,10*Dim,Error)
c     &              -1,rwk,-1,iwk,10*Dim,Error)
      call System_Clock(count2,Rate,Max)
      time1=1.d0*(Count2-Count1)/Rate
      write(6,*) 'Zeit fuer ZHEEVD: ',time1,' sec'
      write(6,*) '# Optimal workspace wk: ',wk(1)
      write(6,*) '# Optimal workspace rwk: ',rwk(1)
      write(6,*) '# Error: ',Error

c$$$      call ZHEEV('N','U',ThisDim,Matrix,Dim,Eigenwerte,wk,
c$$$     &     wkDim,rwk,Error)


*     
*     result
*
      do k=1,ThisDim
         write(6,'(f15.7)') Eigenwerte(k)
      enddo
*
      end
