#!/bin/bash

make clean

make diag

# initial settings

export OMP_NUM_THREADS=8
export OMP_NESTED="TRUE"
export OMP_DYNAMIC="TRUE"
export OMP_SCHEDULE="dynamic"

# cases

export OMP_NUM_THREADS=8
export KMP_AFFINITY="verbose,compact,0,0"
./diag LargeMatrix.asc > diag-omp-08-dynamic-true.out 
# this will be wrong!

export OMP_NUM_THREADS=1
export KMP_AFFINITY="verbose,compact,0,0"
./diag LargeMatrix.asc > diag-omp-01-dynamic-true.out 

export OMP_NUM_THREADS=8
export MKL_NUM_THREADS=1
export KMP_AFFINITY="verbose,compact,0,0"
./diag LargeMatrix.asc > diag-omp-08-mkl-01-dynamic-true.out 

export OMP_NUM_THREADS=8
export KMP_AFFINITY="verbose,compact,0,0"
export OMP_DYNAMIC="FALSE" 
./diag LargeMatrix.asc > diag-omp-08-dynamic-false.out 

export OMP_NUM_THREADS=8
export MKL_NUM_THREADS=8
export OMP_DYNAMIC="FALSE" 
export MKL_DYNAMIC="FALSE"
export KMP_AFFINITY="verbose,compact,0,0"
./diag LargeMatrix.asc > diag-omp-08-false-mkl-08-dynamic-false.out 

export OMP_NUM_THREADS=8
export OMP_NESTED=".TRUE."
export OMP_DYNAMIC=".FALSE."
export OMP_SCHEDULE="dynamic"
./diag LargeMatrix.asc > diag-omp-08-nested-true-dynamic-false-schedule-dynamic.out 


exit
